<template>
  <v-app class="example-drag">
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>

    <!-- icon-top -->
    <v-btn v-scroll="onScroll" v-show="fab" fab x-small dark fixed bottom right color="#428bca" @click="toTop">
      <v-icon>mdi-chevron-up</v-icon>
    </v-btn>
    <!-- icon-top -->

    <!-- upload -->
    <v-card class="example-drag">
      <v-container grid-list-xs>
        <div class="example-drag">
          <div class="upload">
            <div class="text-center p-5" style="border: 3px dashed rgba(28, 110, 164, 0.42); height: 175px">
              <h4 class="mt-5">Drop files anywhere to upload<br />or</h4>
              <label style="display: none" for="file" ref="inputfile" class="btn btn-lg btn-primary">Select Files</label>
              <v-btn for="file" rounded color="primary" dark @click="select_file()">Select Files</v-btn>
              <br />
              <div class="mt-4">
                <span> <B>limit 100 Files / time</B> </span> &nbsp;&nbsp;
                <span>..,</span>
                <span style="color: red">
                  <B> Your files * : {{ length }} files </B>
                </span>
              </div>
            </div>
            <v-container fluid>
              <div justify="space-around">
                <v-row class="py-0">
                  <h4 class="py-5 ml-12">
                    Please select the disease to be examined in the checkboxes*
                  </h4>
                  <v-switch
                    class="py-0 pt-1 ml-2"
                    color="rgb(63, 81, 181)"
                    v-model="switchButton"
                  ></v-switch>
                  <span style="color: rgb(63, 81, 181)" class="py-5">
                    Select All*
                  </span>
                </v-row>
                <!-- จัด UI 4 CHECKBOX -> Abnormal -> Tuberculosis -> Pneumothorax -> Emphysema -->
                <v-row v-if="!Pneumonia" class="py-0 pt-0">
                  <v-col cols="12" sm="3" class="py-0 pt-0">
                    <v-checkbox
                      input-value="true"
                      value="Abnormal"
                      label="Abnormal"
                      v-model="DiseaseFilterCheck"
                      disabled
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="3" class="py-0 pt-0">
                    <v-checkbox
                      input-value="true"
                      value="Tuberculosis"
                      label="Tuberculosis"
                      v-model="DiseaseFilterCheck"
                      disabled
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="3" class="py-0 pt-0" v-if="Pneumothorax != null">
                    <v-checkbox 
                      value="Pneumothorax" 
                      label="Pneumothorax" 
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="3" class="py-0 pt-0" v-if="Emphtsema != null">
                    <v-checkbox 
                      label="Emphysema" 
                      value="Emphysema" 
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                </v-row>
                <!-- จัด UI 5 CHECKBOX -> Abnormal -> Tuberculosis -> Pneumothorax -> Emphysema -> Pneumonia -->
                <v-row v-else class="py-0 pt-0">
                  <v-col cols="12" sm="2" md="2" class="py-0 pt-0">
                    <v-checkbox
                      input-value="true"
                      value="Abnormal"
                      label="Abnormal"
                      v-model="DiseaseFilterCheck"
                      disabled
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="2" md="2" class="py-0 pt-0">
                    <v-checkbox
                      input-value="true"
                      value="Tuberculosis"
                      label="Tuberculosis"
                      v-model="DiseaseFilterCheck"
                      disabled
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="2" md="2" class="py-0 pt-0" v-if="Pneumothorax != null">
                    <v-checkbox
                      value="Pneumothorax"
                      label="Pneumothorax"
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="2" md="2" :class="mobile" v-if="Emphtsema != null">
                    <v-checkbox
                      label="Emphysema"
                      value="Emphysema"
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="2" md="2" :class="mobile" v-if="Pneumonia != null">
                    <v-checkbox
                      label="Pneumonia"
                      value="Pneumonia"
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                  <v-col cols="12" sm="2" md="2" :class="mobile" v-if="Covid19 != null">
                    <v-checkbox
                      label="Covid-19"
                      value="Covid-19"
                      v-model="DiseaseFilterCheck"
                    ></v-checkbox>
                  </v-col>
                </v-row>
              </div>
            </v-container>
            <v-data-table :headers="headers" :items="itemsWithIndex" :items-per-page="5" class="elevation-1">
              <template v-slot:item.progress="{ item }">
                <v-progress-linear
                  color="cyan darken-2"
                  height="15"
                  striped
                  :value="item.progress"
                  style="color: white"
                  >
                  {{ item.progress }}%
                </v-progress-linear>
              </template>
              <template v-slot:item.success="{ item }">
                <v-icon v-if="item.error" color="error">mdi-alert-circle</v-icon>
                <v-icon v-else-if="item.success" color="teal">mdi-check</v-icon>
                <v-icon v-else color="error"></v-icon>
              </template>
              <template v-slot:item.active="{ item }">
                <v-tooltip top>
                  <template v-slot:activator="{ on, attrs }">
                    <v-icon
                      v-bind="attrs"
                      v-on="on"
                      color="error"
                      :disabled="item.progress > 0"
                      style="cursor: pointer"
                      @click="delete_item(item)"
                    >
                      mdi-delete
                    </v-icon>
                  </template>
                  <span>Delete</span>
                </v-tooltip>
              </template>
            </v-data-table>
            <div v-show="$refs.upload && $refs.upload.dropActive" class="drop-active">
              <h3>Drop files to upload</h3>
            </div>
            <!-- post-action="http://203.151.108.14:8000/api/v3/upload?hospital_id=12321&user_id=2165465" -->
            <div class="example-btn">
              <file-upload
                :headers="{ Authorization: token }"
                style="display: none"
                class="btn btn-primary"
                :post-action="api_upload"
                :multiple="true"
                :drop="true"
                :drop-directory="true"
                v-model="files"
                ref="upload"
                @input-file="inputFile"
              >
                <i class="fa fa-plus"></i>
                Select files
              </file-upload>
              <div style="text-align: right">
                <v-btn
                  class="mt-2"
                  type="button"
                  color="#3f51b5"
                  :style="button_mobile"
                  dark
                  v-if="!$refs.upload || !$refs.upload.active"
                  @click.prevent="start_upload"
                >
                  <v-icon>mdi-upload</v-icon>
                  Start Upload
                </v-btn>
                &nbsp;
                <v-btn
                  class="mt-2"
                  type="button"
                  color="error"
                  dark
                  :style="button_mobile"
                  @click.prevent="remove_all()"
                >
                  <v-icon>mdi-delete-sweep</v-icon>
                  Remove All
                </v-btn>
              </div>
            </div>
          </div>
        </div>
      </v-container>
      <!-- upload -->
    </v-card>
  </v-app>
</template>

<script>
import FileUpload from "vue-upload-component";

export default {
  name: "Upload",
  components: {
    FileUpload
  },
  data() {
    return {
      // api: "https://1ls.manageai.co.th",
      // api: "https://1ls-demo.manageai.co.th",
      api: process.env.VUE_APP_API,
      token: this.$cookies.get("info_login").session_id,
      top: "",
      fab: false,
      length: "0",
      switchButton: true,
      list_disease: [],
      DiseaseFilterCheck: [],
      filter_list_disease: [],
      res_info_upload: [],
      check_sucess: [],
      dialog_loader: false,
      //checkbox
      Tuberculosis: "Tuberculosis",
      Abnormal: "Abnormal",
      Pneumothorax: "",
      Emphtsema: "",
      Pneumonia: "",
      Covid19: "",
      //value-checkbox
      valuePneumothorax: "",
      valueEmphtsema: "",
      valuePneumonia: "",
      valueCovid19: "",
      //
      info_login: "",
      api_upload: "",
      files: [],
      limit_file: 100,
      headers: [
        {
          text: "No.",
          align: "start",
          value: "index"
        },
        { text: "File name", value: "name", align: "center" },
        { text: "Progress", value: "progress", align: "center" },
        { text: "Status", value: "success", align: "center" },
        { text: "Action", value: "active", align: "center" }
      ]
    };
  },
  watch: {
    DiseaseFilterCheck(val) {
      if (val.length != this.filter_list_disease.length) {
        this.switchButton = false;
      } else {
        this.switchButton = true;
      }
    },
    switchButton(val) {
      // console.log(val);
      if (val == true) {
        if (val == true) {
          this.DiseaseFilterCheck = this.filter_list_disease;
        }
      } else {
        if ( val == false && this.DiseaseFilterCheck.length == this.filter_list_disease.length) {
          this.DiseaseFilterCheck = ["Abnormal", "Tuberculosis"];
        }
      }
    },
    files(val) {
      console.log(val);
      if (val.length <= this.limit_file) {
        this.length = val.length;
        for (let index = 0; index < val.length; index++) {
          // console.log(val[index].type);
          // console.log(val[index].name);
          var check_type_name = val[index].name;
          var Find_dcm = check_type_name.includes(".dcm");
          var Find_DCM_Large = check_type_name.includes(".DCM");
          if (
            val[index].type == "image/png" ||
            // val[index].type == "image/jpeg" ||
            Find_dcm == true ||
            Find_DCM_Large == true
          ) {
            continue;
          } else {
            this.files.splice(val.length - 1, 1);
            this.$swal({
              icon: "warning",
              title: "Warning!",
              text: "Type file incorrect.",
              confirmButtonText: "OK",
              allowOutsideClick: false
            });
            break;
          }
        }
      } else {
        var delect_length = val.length - this.limit_file;
        this.$swal({
          icon: "warning",
          title: "Warning!",
          text: "100 files limit only.",
          confirmButtonText: "OK",
          allowOutsideClick: false
        }).then(() => {
          this.files.splice(val.length - delect_length, delect_length);
        });
      }
      var list_success = [];
      for (let index = 0; index < val.length; index++) {
        if (val[index].success == true) {
          list_success.push(true);
          if (list_success.length == val.length) {
            localStorage.setItem("DiseaseFilterCheck", JSON.stringify(this.DiseaseFilterCheck));
            this.$store.commit("setDisease", this.DiseaseFilterCheck);
            this.$store.commit("setUpload_id", this.res_info_upload);
            this.dialog_loader = true;
            setTimeout(() => {
              this.$router.push("/display");
              this.dialog_loader = false;
            }, 2000);
          }
        }
      }
    }
  },
  mounted() {
    console.log("api:", this.api)
    this.info_login = this.$cookies.get("info_login");
    // this.api_upload = `http://203.151.108.14:8007/api/v3/upload?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    //this.api_upload = `https://1ls.manageai.co.th/api/v3/upload?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    this.api_upload =
      this.api +
      `/api/v3/upload?hospital_id=${this.info_login.hospital_id}&hospital_name_th=${this.info_login.hospital_name_th}&user_id=${this.info_login.user_id}&username=${this.info_login.username}`;
    this.get_disease();
  },

  computed: {
    itemsWithIndex() {
      return this.files.map((files, index) => ({
        ...files,
        index: index + 1
      }));
    },
    mobile() {
      console.log("breakpoint", this.$vuetify.breakpoint.name);
      switch (this.$vuetify.breakpoint.name) {
        case "xs":
          return "py-0 pt-0";
        default:
          return "py-0 pt-0 pl-7";
      }
    },
    button_mobile() {
      switch (this.$vuetify.breakpoint.name) {
        case "xs":
          return "width:125px;font-size:10px";
        default:
          return "width:180px";
      }
    }
  },

  methods: {
    onScroll(e) {
      if (typeof window === "undefined") return;
      const top = window.pageYOffset || e.target.scrollTop || 0;
      this.fab = top > 25;
    },

    toTop() {
      this.$vuetify.goTo(0);
    },

    get_disease() {
      this.axios
        .get(
          process.env.VUE_APP_API +
            "/api/v3/cxr_hospitalcontract?hospital_id=" +
            this.$cookies.get("info_login").hospital_id
        )
        .then(response => {
          console.log("get_disease", response.data.data);
          this.list_disease = response.data.data;
          // กรองโรคที่ได้จาก response มีแค่เฉพาะ Abnormal -> Tuberculosis -> Pneumothorax -> Emphysema -> Pneumonia ยัดใน filter_list_disease : []
          // 1.Abnormal
          const found_Abnormal = this.list_disease.find(
            element => element == "Abnormal"
          );
          console.log("found =>", found_Abnormal);
          this.filter_list_disease.push(found_Abnormal);
          // 2.Tuberculosis
          const found_Tuberculosis = this.list_disease.find(
            element => element == "Tuberculosis"
          );
          console.log("found =>", found_Tuberculosis);
          this.filter_list_disease.push(found_Tuberculosis);
          // 3.Emphysema
          const foundEmphysema = this.list_disease.find(
            element => element == "Emphysema"
          );
          if (foundEmphysema != null) {
            this.Emphtsema = "Emphysema";
            this.valueEmphtsema = "Emphysema";
            this.filter_list_disease.push(foundEmphysema);
          } else {
            this.Emphtsema = null;
            console.log("Emphtsema=null", this.Emphtsema);
          }
          // 4.Pneumothorax
          const foundPneumothorax = this.list_disease.find(
            element => element == "Pneumothorax"
          );
          if (foundPneumothorax != null) {
            this.Pneumothorax = "Pneumothorax";
            this.valuePneumothorax = "Pneumothorax";
            this.filter_list_disease.push(foundPneumothorax);
          } else {
            this.Pneumothorax = null;
            console.log("foundPneumothorax=null", this.Pneumothorax);
          }
          // 5.Pneumonia
          const foundPneumonia = this.list_disease.find(
            element => element == "Pneumonia"
          );
          if (foundPneumonia != null) {
            this.Pneumonia = "Pneumonia";
            this.valuePneumonia = "Pneumonia";
            this.filter_list_disease.push(foundPneumonia);
          } else {
            this.Pneumonia = null;
            console.log("foundPneumothorax=null", this.Pneumonia);
          }
          // 6.Covid-19
          const foundCovid19 = this.list_disease.find(
            element => element == "Covid-19"
          );
          if (foundCovid19 != null) {
            this.Covid19 = "Covid-19";
            this.valueCovid19 = "Covid-19";
            this.filter_list_disease.push(foundCovid19);
          } else {
            this.Covid19 = null;
            console.log("foundPneumothorax=null", this.Covid19);
          }
          console.log("filter_list_disease", this.filter_list_disease);
          this.DiseaseFilterCheck = this.filter_list_disease;
        })
        .catch(error => {
          console.log(error);
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        });
    },

    inputFile: function(newFile, oldFile) {
      if (newFile && oldFile && !newFile.active && oldFile.active) {
        // Get response data
        console.log("response", newFile.response);
        if (newFile.response.status == "fail") {
          console.log("fail-401");
          this.$refs.upload.active = false;
          this.$swal({
            icon: "error",
            title: "Error!",
            text: "ระบบหมดเวลาการใช้งาน กรุณาทำการเข้าระบบใหม่อีกครั้ง",
            confirmButtonText: "OK",
            allowOutsideClick: false
          }).then(() => {
            this.dialog_loader = false;
            window.location.href = this.api;
          });
        } else {
          this.res_info_upload.push(newFile.response.upload_id);
          console.log("res==>info_login===>)", this.res_info_upload);
        }
      }
    },

    select_file() {
      // this.$refs.inputfile;
      this.$refs.inputfile.click();
    },

    delete_item(item) {
      console.log(item);
      const index = this.itemsWithIndex.indexOf(item);
      this.files.splice(index, 1);
    },

    start_upload() {
      this.$refs.upload.active = true;
    },

    remove_all() {
      // $refs.upload.active = false && files == []
      this.files = [];
    }
  }
};
</script>

<style>
.example-drag label.btn {
  margin-bottom: 0;
  margin-right: 1rem;
}
.example-drag .drop-active {
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  position: fixed;
  z-index: 9999;
  opacity: 0.6;
  text-align: center;
  background: #000;
}
.example-drag .drop-active h3 {
  margin: -0.5em 0 0;
  position: absolute;
  top: 50%;
  left: 0;
  right: 0;
  -webkit-transform: translateY(-50%);
  -ms-transform: translateY(-50%);
  transform: translateY(-50%);
  font-size: 40px;
  color: #fff;
  padding: 0;
}
</style>
